package com.orientechnologies.orient.core;

import com.orientechnologies.orient.core.db.ODatabaseDocumentInternal;
import com.orientechnologies.orient.core.db.ODatabaseRecordThreadLocal;
import com.orientechnologies.orient.core.db.document.ODatabaseDocument;
import com.orientechnologies.orient.core.db.document.ODatabaseDocumentTx;
import com.orientechnologies.orient.core.exception.ODatabaseException;
import com.orientechnologies.orient.core.record.impl.ODocument;
import com.orientechnologies.orient.core.tx.OTransaction;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;

public class ExceptionNotOpenTest {

  @Test
  public void testExceptionNotOpenMemory() {

    ODatabaseDocumentInternal db = new ODatabaseDocumentTx("memory:testExceptionNotOpenMemory");
    try {
      db.save(new ODocument());
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.delete(new ODocument());
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.begin();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.begin(OTransaction.TXTYPE.NOTX);
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.rollback();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.commit();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.getMetadata();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
  }

  @Test
  @Ignore
  public void testExceptionNotOpenRemote() {
    try {
      ODatabaseDocument db = new ODatabaseDocumentTx("remote:127.0.0.1:00");
      Assert.fail();
    } catch (ODatabaseException e) {
      Assert.assertNull(ODatabaseRecordThreadLocal.instance().getIfDefined());
    }
  }

  @Test
  public void testExceptionNotOpenPlocal() {

    ODatabaseDocumentInternal db = new ODatabaseDocumentTx("plocal:./target/databaseCheck");
    try {
      db.save(new ODocument());
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.delete(new ODocument());
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.begin();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.begin(OTransaction.TXTYPE.NOTX);
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.rollback();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.commit();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
    try {
      db.getMetadata();
      Assert.fail();
    } catch (ODatabaseException ex) {
    }
  }
}
